/* synsend v2.0b1 */
/* copyright 2000 bob keyes */
/* all rights reserved */

#include <stdio.h>
#include <libnet.h>

	typedef struct shuffled {
		u_int16_t	port;
		long int random_index;
		} shuffled_t;
	shuffled_t *shuffled;



	static int elemcompare(const void *x, const void *y);
	void srandom(unsigned int seed);
	long int random(void);

int main (int argc, char **argv)
{
	int sock,c,i;
	u_int32_t src_ip,dst_ip;
	u_int16_t src_prt, dst_prt;
	u_char *buf;
	int netsize=65535;



	buf=malloc(IP_MAXPACKET);

	if (argc < 4)
	{printf("\nUSAGE: %s dst-net-addr dst-port src-addr usleep-time\n"
		,argv[0]); exit(1);}
	dst_ip=inet_addr(argv[1]);
	printf("Randomizing port numbers.\n");
	src_ip=inet_addr(argv[3]);
	dst_prt=atoi(argv[2]);
	shuffled=(shuffled_t *)malloc(netsize * sizeof(shuffled_t));
	srandom(time(0));
	for (i=0; i < netsize; i++)
		{
		shuffled[i].port=i;
		shuffled[i].random_index=random();
		}
	qsort(shuffled, netsize, sizeof(shuffled_t),elemcompare);

	if (!buf) {perror("Not enough memory for packet");exit(EXIT_FAILURE);}
	sock=libnet_open_raw_sock(IPPROTO_RAW);
	if (sock == -1) {perror("Can't open raw socket");
	exit(EXIT_FAILURE);}
printf("Sending SYN packets.\n");
for (i=0;i<netsize;i++) {
 src_prt=htons(shuffled[i].port);
libnet_build_ip(TCP_H,IPTOS_LOWDELAY,413,0,67,IPPROTO_TCP,src_ip,dst_ip,NULL,0,buf);
libnet_build_tcp(src_prt,dst_prt,6060842,0,TH_SYN,512,0,NULL,0,buf+ IP_H);
libnet_do_checksum(buf, IPPROTO_TCP, TCP_H);
 c=libnet_write_ip(sock,buf,TCP_H + IP_H);
 if ( c < TCP_H + IP_H) {perror("Can't send packet!");exit(EXIT_FAILURE);}
 usleep(atoi(argv[4]));
 }
 free(buf);
 exit(0);
}


	static int elemcompare(const void *x, const void *y)
	{
	return ((struct shuffled *)y)->random_index - ((struct
        shuffled *)x)->random_index;}

