/*
 * This is the headerfile.c file to Stick version 1.0
 *
 * Written by: Coretez Giovanni
 *
 * This code has the functions that the rules.l will need to 
 * initalize, and send off the packets as specified in the rules.l
 * lexxer.  The procedures generated by rules.l are to put into
 * middlecode.c and are placed in this program by the compiler
 * include option later on.  Therefore, rules.l needs to output
 * is code into the same directory as this code.
 */

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/udp.h>
#include <netinet/ip_icmp.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <fcntl.h>

/*
 * shouts to LMOS, DEVO and Grand Master Sloppy Slop et HAGIS 
 */
/*
#include <netinet/in.h>
#include <netinet/in_system.h>
#include <netinet/ip.h>
*/
/*
* Man ... I really cannot remember if I still need these lines.
*/
#ifndef IP_HDRINCL
#define IP_HDRINCL 3
#endif
#ifndef PF_INET
#define PF_INET 2
#endif
#ifndef AF_INET
#define AF_INET PF_INET
#endif

#define GETLRANDOM	(getrandom (0, 65535) * getrandom (0, 65535))

/*
* Yup ... I need these ...
*/
typedef unsigned char u8;
typedef unsigned short int u16;
typedef unsigned int u32;
/*
* This is the array of pointers to functions.  If there are mode rules
* then increase the number ... It really doesn't hurt to make it a 
* really big number.
*/
void (*funcpnt[5000])();

#ifndef htons

#if __BYTE_ORDER == __BIG_ENDIAN
#define ntohl(x)        (x)
#define ntohs(x)        (x)
#define htonl(x)        (x)
#define htons(x)        (x)
#else
unsigned short int htons (unsigned short int hostshort);
unsigned short int ntohs (unsigned short int netshort);
#endif

#endif

#define IP 0
#define ICMP 1
#define TCP 6
#define UDP 17
#define RAW 255

/*
* NOTE: The code is written for the x86 processor so the endian notation
* needs to be flipped for those more expensive machines .. ie SUN
*/
struct sa
  {
    u16 fam, dp;
    u32 add;
    u8 zero[8];
  }
sadd;

struct new_ip
  {
    u8 ihl:4 , ver:4;
    u8 tos;
    u16 tl, id, off;
    u8 ttl, pro;
    u16 sum;
    u32 src, dst;
  }
 *ih;

struct tcp
  {
    u16 src, dst;
    u32 seq, ackseq;
    u16 res1:4, doff:4, fin:1, syn:1, rst:1, psh:1, ack:1, urg:1, res2:2;
    u16 win, sum, urp;
  }
 *th;

struct udp
  {
    u16 src, dst;
    u16 length, sum;
  }
 *uh;


struct new_icmp
  {
    u8 itype, icode;
    u16 sum;
    u16 id, seq;
    char data[1];
  }
 *icmph;

unsigned int dummy;

unsigned short ip_sum (unsigned short *, int);

int s;


void
usage ()
{
  fprintf(stderr, "\nUsage: stick [sH ip_source] [sC ip_class_C_spoof]");
  fprintf(stderr, " [sR start_spoof_ip end_spoof_ip]\n");
  fprintf(stderr, "             [dH ip_target] [dC ip_class_C_target]");
  fprintf(stderr, " [dR starttargetip end_target_ip]\n");
  fprintf(stderr, " -------------------------------------------------------------------------   \n");
  fprintf(stderr, " defaults destination to 10.0.0.1 and source default");
  fprintf(stderr, " is 0.0.0.0-255.255.255.255 \n");
  fprintf(stderr, " Software Design for limitted Stress Test capablity.\n\n");
  exit (1);
}

/*******************88 List of the random functions 88**************************/

u32 (* sourceptr) ();
u32 (* destptr) ();

unsigned int 	source_startip,
		sourceRange, 
		dest_startip, 
  		destRange;

char rseed[65535];
int rcounter = 0;

/*
* Got these random functions out of some previous edition of Phrack
*
* Shout to whoever wrote them...
*/

void
random_init (void)
{
  int rfd = open ("/dev/urandom", O_RDONLY);
  if (rfd < 0)
    rfd = open ("/dev/random", O_RDONLY);
  rcounter = read (rfd, rseed, 65535);
  close (rfd);
}

inline long
getrandom (int min, int max)
{
  if (rcounter < 2)
    random_init ();
  srand (rseed[rcounter] + (rseed[rcounter - 1] << 8));
  rcounter -= 2;
  return ((random () % (int) (((max) + 1) - (min))) + (min));
}

u32
classC ()
{
   return (u32) (((getrandom (0, 255)) * 0x01000000) + source_startip); 
}

u32
target ()
{
   return (u32) dest_startip; 
}

u32
allsources ()
{
   return GETLRANDOM; 
}

u32
subclassC ()
{
   return (u32) ((getrandom (0, sourceRange)) * 0x01000000 + source_startip); 
}



/*******************88 End of the List of the random functions 88**************************/

/****************88 Command line interface routine ... Not Robust 88***********************/
void
init_arguments (int argc, char * argv[])
{

  int i, dropped, sourcecheck, destinationcheck;

  unsigned int  source_stopip, dest_stopip;

  sourcecheck = 1;
  destinationcheck = 1;

  source_startip = 0;
  source_stopip  = 0xFFFFFFFF;
  dest_startip   = 0x0100000A;
  dest_stopip    = 0x0100000A;
  
  for (i = 1; i < argc; i++)
   {    
     dropped = 1;

     if (strcmp(argv[i],"sC") ==0) {
            i++;
            if (inet_addr(argv[i]) == -1) {
              printf ("Invalid IP Address following range\n");
              }
            else
              {
                source_startip = inet_addr(argv[i]);
              
		sourceptr = classC;  
   		printf ("Class C source with target value of: %x\n", source_startip);
	        sourcecheck = 0;
	        dropped = 0;
              }
     }

     if (strcmp(argv[i],"dC") ==0) {
            i++;
            if (inet_addr(argv[i]) == -1) {
              printf ("Invalid IP Address following range\n");
              }
            else
              {
                dest_startip = inet_addr(argv[i]);

		destptr = classC;  
   		printf ("Class C destination with target value of: %x\n", dest_startip);
	        destinationcheck = 0;
	        dropped = 0;
              }
     }

     if (strcmp(argv[i],"sR") ==0) {
            i++;
            if (inet_addr(argv[i]) == -1) {
              printf ("Invalid IP Address following range\n");
              }
            else
              {
                source_startip = inet_addr(argv[i]);
                i++;
                if (inet_addr(argv[i]) == -1) {
                   printf ("Invalid IP Address following range\n");
                  }
                else
                  {
                     source_stopip = inet_addr(argv[i]);
                     dropped = 0;
                  }
               }
	sourceptr = subclassC;  
    	printf ("Source Range starting at : %x\n", source_startip);
   	printf ("A range value of: %x \n", sourceRange);
        sourcecheck = 0;

   	sourceRange = (source_stopip - source_startip);
   	sourceRange = sourceRange / 0x01000000; 
        }

     if (strcmp(argv[i],"dR") ==0) {
            i++;
            if (inet_addr(argv[i]) == -1) {
              printf ("Invalid IP Address following range\n");
          }
            else
              {
                dest_startip = inet_addr(argv[i]);
                i++;
                if (inet_addr(argv[i]) == -1) {
                   printf ("Invalid IP Address following range\n");
                  }
                else
                  {
                     dest_stopip = inet_addr(argv[i]);
                     dropped = 0;
                  }
               }
        destptr = subclassC;
   	printf ("Dest Range starting at :   %x\n", dest_startip);
   	printf ("A range value of: %x \n", destRange);
	destinationcheck = 0;

   	destRange = (dest_stopip - dest_startip);
   	destRange = destRange / 0x01000000; 
        }

     if (strcmp(argv[i],"sH") ==0) {
         i++;
         source_startip = inet_addr(argv[i]);
         source_stopip = inet_addr(argv[i]);

         sourceptr = target;
   	 printf ("Source ip value of: %x\n", source_startip);
         sourcecheck = 0;
         dropped = 0;
     }
    

     if (strcmp(argv[i],"dH") ==0) {
         i++;
         dest_startip = inet_addr(argv[i]);
         dest_stopip = inet_addr(argv[i]);

	 destptr = target;
   	 printf ("Destination target value of: %x\n", dest_startip);
	 destinationcheck = 0;
         dropped = 0;
     }

    if (dropped) {
      usage ();
    }

   }

  if (sourcecheck) {
    sourceptr = allsources;
    printf ("Stress Test - Source target is set to all 2^32 possiblities\n");
  }

  if (destinationcheck) {
    destptr = target;
    printf ("Destination target value of: %x\n", dest_startip);
    dest_startip = 0x0100000A;
  }

}

/****************88 Command line interface routine ... Not Robust 88***********************/


unsigned short
ip_sum (addr, len)
     unsigned short *addr;
     int len;
{
  register int nleft = len;
  register unsigned short *w = addr;
  register int sum = 0;
  unsigned short answer = 0;

  while (nleft > 1)
    {
      sum += *w++;
      nleft -= 2;
    }
  if (nleft == 1)
    {
      *(unsigned char *) (&answer) = *(unsigned char *) w;
      sum += answer;
    }
  sum = (sum >> 16) + (sum & 0xffff);
  sum += (sum >> 16);
  answer = ~sum;
  return (answer);
}

u32 magic;
char packet[1024], *dh;

/*
* NOTE: I'm going to use just sorry ass uniform distribution.  That
* means that this code is not well adapted to hiding a hack if the 
* administrator is doing a hueristical analysis of the alarm via 
* source port and source IP.  This heuristics problem can be resolved
* by going to college and learning that chi square distrubition and 
* things like that that you though were all crap.  
* Another words.  In order to create a proper computer simulation of 
* noise replace the distribution with a 2-5 spike chi square distribution
* centered around a couple of IP ranges. 
* In other words, this code is not optimzed to support activity that
* the author of this code does not wish to condone. But it is also important
* to note that most security profressionals hold libral arts degrees and
* wouldn't know shit about finding a statistical anomalee on their network
* that's whjy their site sucks so bad and people bitch about their network.
*/

void
cleanTCP ()
{
  sadd.fam = AF_INET;
  sadd.dp = th->dst;
  sadd.add = ih->dst;

  ih->ver = 4;
  ih->ihl = 5;
  ih->tos = 0x00;
  ih->tl = sizeof (struct ip) + sizeof (struct tcp);
  ih->id = getrandom (0, 65535);
  ih->off = 0;
  ih->ttl = getrandom (200, 255);
  ih->pro = TCP;
  ih->sum = 0;
  ih->src = htonl (GETLRANDOM);

  th->seq = htonl (ntohl (ih->src) ^ magic);
  th->src = getrandom (1024, 65535);
  th->dst = getrandom (1024, 65535);
  th->ackseq = htonl (ntohl (ih->dst) ^ magic);
  th->res1 = 0;
  th->doff = 5;
  th->fin = 0;
  th->syn = 0;
  th->ack = 0;
  th->rst = 0;
  th->psh = 0;
  th->urg = 0;
  th->res2 = 0;

  th->win = getrandom (0, 65000);
  th->sum = getrandom (0, 65000);
  th->urg = getrandom (0, 32000);

  memset (dh, 0, 256);
}


void
cleanUDP ()
{
  sadd.fam = AF_INET;
  sadd.dp = th->dst;
  sadd.add = ih->dst;

  ih->ver = 4;
  ih->ihl = 5;
  ih->tos = 0x00;
  ih->tl = sizeof (struct ip) + sizeof (struct udp);
  ih->id = getrandom (0, 65535);
  ih->off = 0;
  ih->ttl = getrandom (200, 255);
  ih->pro = UDP;
  ih->sum = 0;
  ih->src = htonl (GETLRANDOM);

  uh->src = 0;
  uh->dst = 0;
  uh->length = 0;
  uh->sum = 0;

  memset (dh, 0, 256);
}

void
cleanICMP ()
{
  sadd.fam = AF_INET;
  sadd.dp = th->dst;
  sadd.add = ih->dst;

  ih->ver = 4;
  ih->ihl = 5;
  ih->tos = 0x00;
  ih->tl = sizeof (struct ip) + sizeof (struct icmp);
  ih->id = getrandom (0, 65535);
  ih->off = 0;
  ih->ttl = getrandom (200, 255);
  ih->pro = ICMP;
  ih->sum = 0;
  ih->src = htonl (GETLRANDOM);

}

void sendpacket ()
/*
* This just drops our sorry ass packet into the ether.
*/
{
   int i = 1, s;

  struct sockaddr_in sockinfo;

  ih->sum = ip_sum ((u16 *) packet, (4 * ih->ihl + sizeof (struct tcp) + 1) & ~1);

  if ((s = socket (AF_INET, SOCK_RAW, IPPROTO_RAW)) == -1)
    {
      printf("Could not set up socket ... backing off for 15 seconds.\n");
      sleep (15);
    } else {
  if (setsockopt(s, IPPROTO_IP, IP_HDRINCL, &i, sizeof(int)) == -1)
    {
      printf("Setsopcket Option Error\n");
    }
  sockinfo.sin_family = AF_INET;
  sockinfo.sin_addr.s_addr = ih->dst;

  if (sendto(s, packet, ih->tl, 0, (struct sockaddr *) &sockinfo, sizeof (struct sockaddr)) == -1)
    {
      printf("Problem in Sendto call\n");
    }};
  close (s);
  
}

u16 endian16 (u16 current)
{
  u16 temp;

  temp = current << 8;
  current = current >> 8;
  temp = temp + current;
  return temp;
}

#include "middlecode.c"
